local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_MONEY"); -- Fired when user receive ou spend money
frame:RegisterEvent("GUILDBANKFRAME_OPENED"); -- Fired when user open guild bank
frame:RegisterEvent("PLAYER_ENTERING_WORLD"); -- Fired when user open guild bank


function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function frame:OnEvent(event, arg1)
  if event == "ADDON_LOADED" and arg1 == "GuildDonation" then
    -- Our saved variables are ready at this point. If there are none, all variables will set to nil.
    if TotalDevido == nil then
      TotalDevido = 0; -- This is the first time this addon is loaded; initialize the count to 0.
    end
    if GuildDonationLog == nil then
      GuildDonationLog = {}; -- This is the first time this addon is loaded; initialize the guild log to empty table.
    end
    if GuildDonationFreshInstalled == nil then
      GuildDonationFreshInstalled = true; -- This is the first time this addon is ever loaded after the instalation; initialize the flag with true.
    end
    if Porcentagem == nil then
      Porcentagem = 5; -- This is the first time this addon is loaded; initialize the count to 5%.
    end
  elseif event == "PLAYER_MONEY" then
    -- User received or spended money
    local money = GetMoney()
    -- User received money
    if money > TotalDeGold then
      local divida = money - TotalDeGold;
      divida = math.floor(math.floor(divida/100)*Porcentagem);
      TotalDevido = TotalDevido + divida;
    end
    TotalDeGold = money;
  elseif event == "PLAYER_ENTERING_WORLD" then
    if GuildDonationFreshInstalled == true then
      TotalDeGold = GetMoney(); -- This is the first time this addon is loaded; initialize the count to user current money.
      GuildDonationFreshInstalled = false;
    end
  elseif event == "GUILDBANKFRAME_OPENED" then
    -- User opened guild bank
    DepositGuildBankMoney(TotalDevido)
    local money = TotalDevido
    local gold = floor(abs(money / 10000))
    local silver = floor(abs(mod(money / 100, 100)))
    local copper = floor(abs(mod(money, 100)))
    print(format("|cfff48cba <GuildDonation> |r Your donation of %d gold %d silver %d copper has been done.", gold, silver, copper))
    addlog(TotalDevido)
    TotalDevido = 0
  end
end

function isint(n)
  if tonumber(n) ~= nil then
     return tonumber(n)==math.floor(tonumber(n))
  end
end

function addlog( gold )
  local logsize = tablelength(GuildDonationLog)
  if(logsize) < 20 then
    GuildDonationLog[logsize + 1] = gold
  else
    for i = 2, logsize do
      GuildDonationLog[i - 1] = GuildDonationLog[i]
    end
    GuildDonationLog[logsize] = gold
  end
end

function printlog(  )
  local logsize = tablelength(GuildDonationLog)
  print(format("|cfff48cba <GuildDonation> |r Donation Log :"))
  if logsize == 0 then
    print(format("|cfff48cba <GuildDonation> |r Your donation log is empty."))
  else
    for i = 1, logsize do
      local money = GuildDonationLog[i]
      local gold = floor(abs(money / 10000))
      local silver = floor(abs(mod(money / 100, 100)))
      local copper = floor(abs(mod(money, 100)))
      print(format("|cfff48cba <GuildDonation> |r %d : %d gold %d silver %d copper", (logsize + 1 - i), gold, silver, copper))
    end
  end
end

frame:SetScript("OnEvent", frame.OnEvent);
SLASH_GUILDDONATION1 = "/gd";
function SlashCmdList.GUILDDONATION(msg)

  if msg == "" then
    local money = TotalDevido
    local gold = floor(abs(money / 10000))
    local silver = floor(abs(mod(money / 100, 100)))
    local copper = floor(abs(mod(money, 100)))
    print(format("|cfff48cba <GuildDonation> |r Your current donation is %d gold %d silver %d copper to the guild.", gold, silver, copper))
    print(format("|cfff48cba <GuildDonation> |r Your current donation percentage is %d%%.", Porcentagem))
  else 
    if isint(msg) then
      local number = math.floor(tonumber(msg))
      if number >= 1 or number <= 100 then
        Porcentagem = number
        print(format("|cfff48cba <GuildDonation> |r Your donation percentage is %d%% now.",Porcentagem))
      else
        print(format("|cfff48cba <GuildDonation> |r Invalid number.",Porcentagem))
      end
    elseif msg == "log" then
      printlog()
    else
      local money = TotalDevido
      local gold = floor(abs(money / 10000))
      local silver = floor(abs(mod(money / 100, 100)))
      local copper = floor(abs(mod(money, 100)))
      print(format("|cfff48cba <GuildDonation> |r Your current donation is %d gold %d silver %d copper to the guild.", gold, silver, copper))
      print(format("|cfff48cba <GuildDonation> |r Your current donation percentage is %d%%.", Porcentagem))
    end
  end
end


